#include <graphics.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>

//double
float
re,//aktueller RealWert
//rr,//wurde zur Berechnung des Abbruchkriteriums (r+i > 100) verwendet, jetzt im 387
rs=-2.05,//Real-StartWert
rq= 0.75,//Real-EndWert
ra,//0.005,//RealTeil-AddWert
//ii,//Berechnung des Abbruchkriteriums
im=-1.15,//ImaginrTeil, gleichzeitig Startwert
iq= 1.15,//Imag-EndWert
ia,//0.005,//Wert, der zum ImagTeil addiert wird
thres=100.0,
jj;//Debug
int b,d,j,k,l,x,y,gm=0,gd=0,stat;

main(void){
    extern void _Cdecl SVGA_driver(void);
    int /*grmode = 0,*/GraphDriver,GraphMode=5,maxx,maxy;
//  initgraph(&gm,&gd,"\\tc\\bgi");
//  initgraph(&gm,&gd,"..\\bgi");

    if ((GraphDriver = installuserdriver("SVGA", NULL)) < 0)
        printf("Treiber kann nicht installiert werden");
    if (registerbgidriver(SVGA_driver) < 0)
        printf("Treiber kann nicht registriert werden");
/*    if (registerbgifont(sansserif_font) < 0)
        printf("Zeichensatz kann nicht registriert werden");

    printf("\nBitte den Modus eingeben ");
    scanf("%d",&grmode);

    printf("\nEingabe: %d",grmode);

    GraphMode = grmode;
*/
    initgraph(&GraphDriver, &GraphMode, "");
    if (graphresult() != grOk )
        printf("Grafik kann nicht initialisiert werden");
  maxx=getmaxx();maxy=getmaxy();
  ra=(rq-rs)/(maxx+1);ia=(iq-im)/(maxy+1);
  rs=-0.56 ;ra=0.000025;im=0.53;ia=0.000025;
  rs=-0.57;ra=0.00004;im=0.525;ia=0.00005;
  rs=-0.58;ra=0.00004;im=0.530;ia=0.00005;

  /*
  Die Sache mit dem 80x87-Stack ist anfangs schwer zu durchschauen.
  Hat man das Prinzip verstanden, ist es eigentlich ganz einfach.
  I.d.R. wird bei load-Befehlen nach st(0) gespeichert und alle Stackinhalte "wandern um eine Stelle nach rechts".
  (In Wirklichkeit bleiben sie in den jeweiligen Registern, der Stackpointer stp wird gendert.)
  Ausnahme: bei den Befehlen, die auf p (pop) enden, wandern die Inhalte um eine Stelle nach links.

  st ist gleichbedeutend mit st(0).
  fst jj  speichert st(0) ins Ram, damit man es im watch-Fenster sehen kann.
  fmul st,st  quadriert den Inhalt von st(0)

  fld st(2)  kopiert den Inhalt von (ursprnglich) st(2) nach st(0), nachdem alle Register um eins nach rechts verschoben wurden
  fadd st,st(1) addiert st(1) auf st(0)
  fmul st,st(2) multipliziert st(2) auf st(0)
  fstp st(3) kopiert st(0) nach st(3) und rckt alle Register nach links, die Quelle (st(0)) geht verloren (pop)

  Beachte: der Kommentar bezieht sich immer auf das Ergebnis, fr die Operanden daher immer auf den vorhergehenden Kommentar schauen.

  Hilfreich zum ben: der debug.com / debug.exe von DRDOS (MSdos-Alternative von Digital Research) kann die Floating-Register
  anzeigen (Online-Hilfe befragen).

  die Formeln lauten:
  rneu = r*r-i*i+re;
  ineu = 2*r*i  +im;
  r    = rneu;
  i    = ineu;

  Noch besser wre es, im Register st(7) den Compare-Wert zu halten, da dieser fter als der ia-Wert gebraucht wird,
  aber ich wei im Augenblick nicht auswendig,
  wie ich das Ergebnis (Flags) eines float-compares in den Prozessor bekomme, um einen jle o.. auszufhren.

  */
  asm{                  //st(0)  (1)  (2)  (3)  (4)  (5)  (5)  (7)
//    fld ia              //ia
    fld thres           //thres
    fld im}             //im     ia
  for(y=0;y<=maxy;y++){
    re=rs; //Zeilenanfang, Startwert
    asm{
      fld ra            //ra     im    ia
      fld re            //re     ra    im   ia
      }
    for(x=0;x<=maxx;x++){
      d=0;

      asm{
	fld st(2)       //i      re    ra   im   ia
	fld st(1)       //r      i     re   ra   im   ia
	}

      do
	asm{

	  fld st        //r      r     i    re   ra   im   ia
//          fst jj        //debug
	  fmul st,st    //r     r     i    re   ra   im   ia
//          fst rr        //fr die externe Betragsberechnung
	  fld st(2)     //i      r    r    i    re   ra   im   ia
//          fst jj        //debug
	  fmul st,st    //i     r    r    i    re   ra   im   ia
//          fst ii        //fr die externe Betragsberechnung
	  fadd st,st(1) //i+r  r    r    i    re   ra   im   ia
//          fst rr        //der fertige Betrag
  //        fist b        //als Integer geht's schneller, das reicht fr den Vergleich aus
          fcom st(7)
          fstsw ax
//          fstsw stat
          sahf
          jnc loopend
	  fsub st,st(1) //i     r    r    i    re   ra   im   ia Addition rckgngig machen
//          fsubp st(1),st //Addition rckgngig machen, klappt nicht so, da Stack-underflow
	  fsubp         //r-i  r     i    re   ra   im   ia      fsub = fsubp = fsubp st(1),st
//          fst jj        //debug
	  fadd st,st(3) //erg    r     i    re   ra   im   ia      (erg = r-i+re)
//          fst jj        //debug
	  fld st(2)     //i      erg   r    i    re   ra   im   ia
//          fst jj        //debug
	  fadd st,st(0) //2i     erg   r    i    re   ra   im   ia
//          fst jj        //debug
	  fmul st,st(2) //2ri    erg   r    i    re   ra   im   ia
//          fst jj        //debug
	  fadd st,st(6) //2ri+im erg   r    i    re   ra   im   ia
//          fst jj        //debug
	  fstp st(3)    //erg    r     ineu re   ra   im   ia      (2ri+im -> ineu)
//          fst jj        //debug
	  fstp st(1)    //rneu   ineu  re   ra   im   ia           (erg -> rneu)
//          fst jj        //debug
	  inc d
	  }
//	while((rr+ii<100)&&(d<2000));
//	while((b<170)&&(d<256));
	while((d<4096));
      asm {jmp afterloop}
loopend: asm {ffree st(0);fincstp;ffree st(0);fincstp}
afterloop:
      asm{
//	  fst jj
//	  fstcw &jp
	ffree st(0)
	fincstp
	ffree st(0)
	fincstp
//        fst jj
//        ffree st(1)
//	fistp b         //ineu   re    ra   im    ia               alte Werte poppen (Integer ist schneller)
//	fistp b         //re     ra    im   ia
//        fdecstp //geht nicht
//        fdecstp
//	ffree st(0)
//	ffree st(1)
	fadd st,st(1)   //reneu  ra    im   ia                     Realteil (x) um ra erhhen
//        fst re        //debug
	}
      putpixel(x,y,d==4096?0:(d>70?20:d % 16));
//      putpixel(x,y,d %16);
      }//    for(x=0;x<640;x++){
    asm{
//      fstp rr       //alte Werte entsorgen (wie knnte das besser (ohne Memory-Zugriff) gehen??)
//      fstp ii
//      fistp b           //ra     im    ia                          alte Werte poppen (entsorgen)
//      fistp b           //im     ia
      ffree st(0)
      fincstp
      ffree st(0)
      fincstp

//      fadd st,st(1)     //imneu  ia                                Imaginrteil (y) um ia erhhen
      fld ia
      faddp st(1),st(0)     //imneu  ia                                Imaginrteil (y) um ia erhhen

//      fst im            //debug
      }//asm{
    }//  for(y=0;y<480;y++){

  asm{
//    fstp rr  //alte Werte entsorgen
//    fstp ii
//    fistp b  //alte Werte poppen (entsorgen)
//    fistp b
    ffree st(0)
    fincstp
    ffree st(0)
    fincstp
    }//asm{

  getch();
  return 0;
  } //main(void)
